import { HasCSSSymbol } from "./css";
import { EffectFn, FucoComponent } from "./hook";
export interface AttributeConverter<T> {
    (attr: string | null): T;
}
export declare abstract class Component extends HTMLElement implements FucoComponent {
    private _dirty;
    private _connected;
    private _container;
    _hooks: import("./hook").Hooks<unknown>;
    abstract renderer(node: Node): void;
    protected connectedCallback(): void;
    protected disconnectedCallback(): void;
    update(): void;
    _performUpdate(): void;
    _flushEffects(effects: EffectFn[]): void;
    _attr<T>(name: string, converter?: AttributeConverter<T>): string | T | null;
    _observeAttr(name: string, callback: () => void): () => void;
    _dispatch<T>(name: string, init: CustomEventInit<T>): void;
    _adoptStyle(css: HasCSSSymbol): void;
}
