import { Component, AttributeConverter } from "./component";
import { HasCSSSymbol } from "./css";
export interface Hooks<T> {
    _values: T[];
    _deps: Deps[];
    _effects: EffectFn[];
    _layoutEffects: EffectFn[];
    _cleanup: Cleanup[];
}
export declare type Deps = unknown[];
export declare type EffectFn = () => void | Cleanup;
export declare type Cleanup = () => void;
export interface FucoComponent {
    _hooks: Hooks<unknown>;
    _attr<T>(name: string, converter?: AttributeConverter<T>): T | string | null;
    _observeAttr(name: string, callback: () => void): void;
    _dispatch<T>(name: string, init: CustomEventInit<T>): void;
    _adoptStyle(css: HasCSSSymbol): void;
}
export declare function defaultHooks(): Hooks<unknown>;
export declare function __setCurrent__(c: FucoComponent): void;
export declare function hooks<T>(config: {
    _onmount?: (h: Hooks<T>, c: Component, i: number) => T;
    _onupdate?: (h: Hooks<T>, c: Component, i: number) => void;
}): T;
