export declare type Mutation = AttributeMutation | NodeMutation;
export interface NodeMutation {
    node: Node;
    isSvg: boolean;
    _prev?: unknown;
}
export interface AttributeMutation {
    node: Node;
    name: string;
    _prev?: unknown;
}
export interface TemplateMutation extends NodeMutation {
    _mutations: ChildMutations[];
}
export declare type ChildMutations = NodeMutation[] & {
    _marks: readonly [Node, Node];
};
export interface TextMutation extends NodeMutation {
    _texts: Text[];
}
export declare function isAttributeMutation(m: Mutation): m is AttributeMutation;
export declare function isTemplateMutation(m: Mutation): m is TemplateMutation;
