declare const Template: unique symbol;
export declare type HtmlTemplate = {
    [Template]: [VDOM[], ArgValues];
};
export declare type VDOM = VNode | VText | VArg;
export declare type VNode = {
    tag: string;
    props?: VProps;
    children: VDOM[];
};
export declare type VProps = {
    [name: string]: VPropValue;
};
export declare type VPropValue = VText | VArg | VProps;
export declare type VText = string;
export declare type VArg = number;
export declare type ArgValues = IArguments | Array<unknown>;
export declare function createTemplate(vdom: VDOM[], args: ArgValues): HtmlTemplate;
export declare function isTemplate(t: unknown): t is HtmlTemplate;
export declare function isVNode(vdom: unknown): vdom is VNode;
export declare function items(t: HtmlTemplate): [VDOM[], ArgValues];
export declare function getArgs(t: HtmlTemplate): ArgValues;
export declare function getKey(t: unknown): unknown;
export declare function equalsTemplate(t1: HtmlTemplate, t2: HtmlTemplate): boolean;
export declare function isSvgTag(tag: string): boolean;
export {};
